<?php
namespace Controllers; 

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification; 



class Ger83000InvestimentoController extends \Teknisa\Libs\Controller\CRUD{
    protected $environment;
    protected $connection;
    protected $dataSourceManager;
    
    
    public function __construct($crudService, $environment, $connection, $dataSourceManager) {
        parent::__construct($crudService, $environment);
        
        $this->environment = $environment;
        $this->connection = $connection;
        $this->dataSourceManager    = $dataSourceManager;
    }
    
    public function excluiImposto(DTO\Request $request, DTO\Response $response ){
        $rows = $request->getDataSet()->getRows();
        $investVinculado = "";
        $i  = 0;
        if($rows != null){
            
                foreach ($rows as $row) {
                    try{
                        
                        $filtro = array(
                            array(
                                "columnName" => "CDINVEST",
                                "operator" => "=",
                                "value" => $row["CDINVEST"]
                            ),
                            array(
                                "columnName" => "NMINVEST",
                                "operator" => "=",
                                "value" => $row["NMINVEST"]
                            )
                        );
                        $dataSetProd = $this->crudService->getFilteredDataSet('investimentos', $filtro);
            		    $this->dataSourceManager->delete($dataSetProd);

                    }catch(\Exception $ex){
                         if(strpos($ex->getMessage(), "ORA-02292") === FALSE){
                           $response->setError(new Error("FALHA_PROC_DADOS " . $ex->getMessage(), 500));
                        }else{
                            $investVinculado .= "'".$row["NMINVEST"] . "', ";
                            $i .= 1;
                        }   
                    }
                }
                
                if(!empty($investVinculado)){
                                
                    if($i > 1){
                        $response->setError(new Error("N_POSSIVEL_EXCL_INVESTS " . $investVinculado, 500));
                    }else{
                        $response->setError(new Error("N_POSSIVEL_EXCL_INVEST " . $investVinculado, 500));
                    }
                }
        }
    }

    
}


