<?php
namespace Services;

use Zeedhi\Framework\DTO;

class Gop00800TaxaAdministraivaService {
    protected $connection;
    
    public function __construct($entityManager, $environment){
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    public function insertTaxaAdministrativa($params, $nmtabela, $cdcampo) {
        $query = "INSERT INTO ". $nmtabela ." 
                    (NR". $nmtabela .", ". $cdcampo .", CDANO, NRORG, VRMES01, VRMES02,
                     VRMES03, VRMES04, VRMES05, VRMES06, VRMES07, VRMES08,
                     VRMES09, VRMES10, VRMES11, VRMES12, DTINCLUSAO, CDOPERINCLUSAO,
                     NRORGINCLUSAO, IDATIVO) 
                VALUES(:P_NR". $nmtabela .", :P_". $cdcampo .", :P_CDANO, :P_NRORG,
                       :P_VRMES01, :P_VRMES02, :P_VRMES03, :P_VRMES04,
                       :P_VRMES05, :P_VRMES06, :P_VRMES07, :P_VRMES08,
                       :P_VRMES09, :P_VRMES10, :P_VRMES11, :P_VRMES12,
                       TO_DATE(:P_DTINCLUSAO), :P_CDOPERINCLUSAO,
                       :P_NRORGINCLUSAO, 'S') ";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function updateTaxaAdministrativa($params, $nmtabela) {
        $query = "UPDATE ". $nmtabela ."
                     SET VRMES01 = :P_VRMES01,
                         VRMES02 = :P_VRMES02,
                         VRMES03 = :P_VRMES03,
                         VRMES04 = :P_VRMES04,
                         VRMES05 = :P_VRMES05,
                         VRMES06 = :P_VRMES06,
                         VRMES07 = :P_VRMES07,
                         VRMES08 = :P_VRMES08,
                         VRMES09 = :P_VRMES09,
                         VRMES10 = :P_VRMES10,
                         VRMES11 = :P_VRMES11,
                         VRMES12 = :P_VRMES12,
                         DTULTATU = :P_DTULTATU,
                         NRORGULTATU = :P_NRORGULTATU,
                         CDOPERULTATU = :P_CDOPERULTATU
                     WHERE NR".$nmtabela." = :P_NR" . $nmtabela;
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function insertCadAuto($params, $nmtabela, $cdcampo, $stringMeses, $stringParamMeses) {
        $query = "INSERT INTO ". $nmtabela ."  
                    (NR". $nmtabela .", ". $cdcampo .", CDANO, NRORG, DTINCLUSAO,
                     CDOPERINCLUSAO, NRORGINCLUSAO, IDATIVO ". $stringMeses ." ) 
                VALUES(:P_NR". $nmtabela .", :P_". $cdcampo .", :P_CDANO, :P_NRORG, TO_DATE(:P_DTINCLUSAO),
                       :P_CDOPERINCLUSAO, :P_NRORGINCLUSAO, 'S' "
                        . $stringParamMeses .")";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function updateCadAuto($params, $nmtabela, $stringMeses) {
        $query = "UPDATE ". $nmtabela ."
                     SET DTULTATU = TO_DATE(:P_DTULTATU),
                         CDOPERULTATU = :P_CDOPERULTATU,
                         NRORGULTATU = :P_NRORGULTATU ". $stringMeses .
                     " WHERE NR". $nmtabela ." = :P_NR". $nmtabela;
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
}